///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains error & message codes for IceCore.
 *	\file		IceCoreErrors.h
 *	\author		Pierre Terdiman
 *	\date		July, 8, 2001
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICECOREERRORS_H__
#define __ICECOREERRORS_H__

	// Error codes for IceCore
	extern ICECORE_API const char* EC_OUTOFMEMORY;
	extern ICECORE_API const char* EC_FILENOTFOUND;
	extern ICECORE_API const char* EC_INVALIDCALLBACK;
	extern ICECORE_API const char* EC_REPLICATIONFAILED;
	extern ICECORE_API const char* EC_TOOMANYMSGS;
	extern ICECORE_API const char* EC_CORRUPTEDKERNEL;
	extern ICECORE_API const char* EC_LOSTCELLS;
	extern ICECORE_API const char* EC_INCOMPATIBLEFIELDS;

	// Script-related
	extern ICECORE_API const char* EC_INVALIDPARAMNUMBER;
	extern ICECORE_API const char* EC_INVALIDPARAMTYPE;
	extern ICECORE_API const char* EC_INVALIDIFDEF;
	extern ICECORE_API const char* EC_INVALIDENDIF;

	// Messages codes for IceCore
	extern ICECORE_API const char* KM_SELFDESTRUCT;
	extern ICECORE_API const char* KM_CORRUPTEDDELETION;
	extern ICECORE_API const char* KM_INVALIDREFERENCE;
	extern ICECORE_API const char* KM_CELLMODIFICATION;
	extern ICECORE_API const char* KM_FIELDMODIFICATION;

#endif // __ICECOREERRORS_H__
