///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains code to get system information.
 *	\file		IceSysInfo.h
 *	\author		Pierre Terdiman
 *	\date		November, 5, 2001
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICESYSINFO_H__
#define __ICESYSINFO_H__

	struct ICECORE_API SystemInfo
	{
		sdword	DriverVersion;
		sdword	Width;
		sdword	Height;
		sdword	BPP;
	};

	FUNCTION ICECORE_API void	GetSystemInfo(SystemInfo& si);
	FUNCTION ICECORE_API void	GetSystemDate(String& date);
	FUNCTION ICECORE_API void	GetSystemTime(String& time);
	FUNCTION ICECORE_API void	GetSystem(String& os);
	FUNCTION ICECORE_API udword	GetFreeRam();

	// Directories
	FUNCTION ICECORE_API bool	GetCurrentDir(String& directory);
	FUNCTION ICECORE_API bool	GetSystemDir(String& directory);
	FUNCTION ICECORE_API bool	GetWindowsDir(String& directory);

#endif // __ICESYSINFO_H__

